dev-libs/libusb: stable 1.0.21 for sparc, bug #630342
[gentoo.git] / eclass / eutils.eclass
1 # Copyright 1999-2018 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3
4 # @ECLASS: eutils.eclass
5 # @MAINTAINER:
6 # base-system@gentoo.org
7 # @BLURB: many extra (but common) functions that are used in ebuilds
8 # @DESCRIPTION:
9 # The eutils eclass contains a suite of functions that complement
10 # the ones that ebuild.sh already contain.  The idea is that the functions
11 # are not required in all ebuilds but enough utilize them to have a common
12 # home rather than having multiple ebuilds implementing the same thing.
13 #
14 # Due to the nature of this eclass, some functions may have maintainers
15 # different from the overall eclass!
16
17 if [[ -z ${_EUTILS_ECLASS} ]]; then
18 _EUTILS_ECLASS=1
19
20 # implicitly inherited (now split) eclasses
21 case ${EAPI:-0} in
22 0|1|2|3|4|5|6)
23         inherit desktop epatch estack ltprune multilib preserve-libs toolchain-funcs
24         ;;
25 esac
26
27 # @FUNCTION: eqawarn
28 # @USAGE: [message]
29 # @DESCRIPTION:
30 # Proxy to ewarn for package managers that don't provide eqawarn and use the PM
31 # implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
32 # profile.
33 if ! declare -F eqawarn >/dev/null ; then
34         eqawarn() {
35                 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
36                 :
37         }
38 fi
39
40 # @FUNCTION: ecvs_clean
41 # @USAGE: [list of dirs]
42 # @DESCRIPTION:
43 # Remove CVS directories recursiveley.  Useful when a source tarball contains
44 # internal CVS directories.  Defaults to $PWD.
45 ecvs_clean() {
46         [[ $# -eq 0 ]] && set -- .
47         find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
48         find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
49 }
50
51 # @FUNCTION: esvn_clean
52 # @USAGE: [list of dirs]
53 # @DESCRIPTION:
54 # Remove .svn directories recursiveley.  Useful when a source tarball contains
55 # internal Subversion directories.  Defaults to $PWD.
56 esvn_clean() {
57         [[ $# -eq 0 ]] && set -- .
58         find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
59 }
60
61 # @FUNCTION: egit_clean
62 # @USAGE: [list of dirs]
63 # @DESCRIPTION:
64 # Remove .git* directories/files recursiveley.  Useful when a source tarball
65 # contains internal Git directories.  Defaults to $PWD.
66 egit_clean() {
67         [[ $# -eq 0 ]] && set -- .
68         find "$@" -type d -name '.git*' -prune -print0 | xargs -0 rm -rf
69 }
70
71 # @FUNCTION: emktemp
72 # @USAGE: [temp dir]
73 # @DESCRIPTION:
74 # Cheap replacement for when debianutils (and thus mktemp)
75 # does not exist on the users system.
76 emktemp() {
77         local exe="touch"
78         [[ $1 == -d ]] && exe="mkdir" && shift
79         local topdir=$1
80
81         if [[ -z ${topdir} ]] ; then
82                 [[ -z ${T} ]] \
83                         && topdir="/tmp" \
84                         || topdir=${T}
85         fi
86
87         if ! type -P mktemp > /dev/null ; then
88                 # system lacks `mktemp` so we have to fake it
89                 local tmp=/
90                 while [[ -e ${tmp} ]] ; do
91                         tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
92                 done
93                 ${exe} "${tmp}" || ${exe} -p "${tmp}"
94                 echo "${tmp}"
95         else
96                 # the args here will give slightly wierd names on BSD,
97                 # but should produce a usable file on all userlands
98                 if [[ ${exe} == "touch" ]] ; then
99                         TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
100                 else
101                         TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
102                 fi
103         fi
104 }
105
106 # @FUNCTION: edos2unix
107 # @USAGE: <file> [more files ...]
108 # @DESCRIPTION:
109 # A handy replacement for dos2unix, recode, fixdos, etc...  This allows you
110 # to remove all of these text utilities from DEPEND variables because this
111 # is a script based solution.  Just give it a list of files to convert and
112 # they will all be changed from the DOS CRLF format to the UNIX LF format.
113 edos2unix() {
114         [[ $# -eq 0 ]] && return 0
115         sed -i 's/\r$//' -- "$@" || die
116 }
117
118 # @FUNCTION: strip-linguas
119 # @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
120 # @DESCRIPTION:
121 # Make sure that LINGUAS only contains languages that
122 # a package can support.  The first form allows you to
123 # specify a list of LINGUAS.  The -i builds a list of po
124 # files found in all the directories and uses the
125 # intersection of the lists.  The -u builds a list of po
126 # files found in all the directories and uses the union
127 # of the lists.
128 strip-linguas() {
129         local ls newls nols
130         if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
131                 local op=$1; shift
132                 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
133                 local d f
134                 for d in "$@" ; do
135                         if [[ ${op} == "-u" ]] ; then
136                                 newls=${ls}
137                         else
138                                 newls=""
139                         fi
140                         for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
141                                 if [[ ${op} == "-i" ]] ; then
142                                         has ${f} ${ls} && newls="${newls} ${f}"
143                                 else
144                                         has ${f} ${ls} || newls="${newls} ${f}"
145                                 fi
146                         done
147                         ls=${newls}
148                 done
149         else
150                 ls="$@"
151         fi
152
153         nols=""
154         newls=""
155         for f in ${LINGUAS} ; do
156                 if has ${f} ${ls} ; then
157                         newls="${newls} ${f}"
158                 else
159                         nols="${nols} ${f}"
160                 fi
161         done
162         [[ -n ${nols} ]] \
163                 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
164         export LINGUAS=${newls:1}
165 }
166
167 # @FUNCTION: built_with_use
168 # @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
169 # @DESCRIPTION:
170 #
171 # Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
172 #
173 # A temporary hack until portage properly supports DEPENDing on USE
174 # flags being enabled in packages.  This will check to see if the specified
175 # DEPEND atom was built with the specified list of USE flags.  The
176 # --missing option controls the behavior if called on a package that does
177 # not actually support the defined USE flags (aka listed in IUSE).
178 # The default is to abort (call die).  The -a and -o flags control
179 # the requirements of the USE flags.  They correspond to "and" and "or"
180 # logic.  So the -a flag means all listed USE flags must be enabled
181 # while the -o flag means at least one of the listed IUSE flags must be
182 # enabled.  The --hidden option is really for internal use only as it
183 # means the USE flag we're checking is hidden expanded, so it won't be found
184 # in IUSE like normal USE flags.
185 #
186 # Remember that this function isn't terribly intelligent so order of optional
187 # flags matter.
188 built_with_use() {
189         local hidden="no"
190         if [[ $1 == "--hidden" ]] ; then
191                 hidden="yes"
192                 shift
193         fi
194
195         local missing_action="die"
196         if [[ $1 == "--missing" ]] ; then
197                 missing_action=$2
198                 shift ; shift
199                 case ${missing_action} in
200                         true|false|die) ;;
201                         *) die "unknown action '${missing_action}'";;
202                 esac
203         fi
204
205         local opt=$1
206         [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
207
208         local PKG=$(best_version $1)
209         [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
210         shift
211
212         has "${EAPI:-0}" 0 1 2 && local EROOT=${ROOT}
213         local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
214         local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
215
216         # if the IUSE file doesn't exist, the read will error out, we need to handle
217         # this gracefully
218         if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
219                 case ${missing_action} in
220                         true)   return 0;;
221                         false)  return 1;;
222                         die)    die "Unable to determine what USE flags $PKG was built with";;
223                 esac
224         fi
225
226         if [[ ${hidden} == "no" ]] ; then
227                 local IUSE_BUILT=( $(<"${IUSEFILE}") )
228                 # Don't check USE_EXPAND #147237
229                 local expand
230                 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
231                         if [[ $1 == ${expand}_* ]] ; then
232                                 expand=""
233                                 break
234                         fi
235                 done
236                 if [[ -n ${expand} ]] ; then
237                         if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
238                                 case ${missing_action} in
239                                         true)  return 0;;
240                                         false) return 1;;
241                                         die)   die "$PKG does not actually support the $1 USE flag!";;
242                                 esac
243                         fi
244                 fi
245         fi
246
247         local USE_BUILT=$(<${USEFILE})
248         while [[ $# -gt 0 ]] ; do
249                 if [[ ${opt} = "-o" ]] ; then
250                         has $1 ${USE_BUILT} && return 0
251                 else
252                         has $1 ${USE_BUILT} || return 1
253                 fi
254                 shift
255         done
256         [[ ${opt} = "-a" ]]
257 }
258
259 # @FUNCTION: make_wrapper
260 # @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
261 # @DESCRIPTION:
262 # Create a shell wrapper script named wrapper in installpath
263 # (defaults to the bindir) to execute target (default of wrapper) by
264 # first optionally setting LD_LIBRARY_PATH to the colon-delimited
265 # libpaths followed by optionally changing directory to chdir.
266 make_wrapper() {
267         local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
268         local tmpwrapper=$(emktemp)
269         has "${EAPI:-0}" 0 1 2 && local EPREFIX=""
270
271         (
272         echo '#!/bin/sh'
273         [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
274         if [[ -n ${libdir} ]] ; then
275                 local var
276                 if [[ ${CHOST} == *-darwin* ]] ; then
277                         var=DYLD_LIBRARY_PATH
278                 else
279                         var=LD_LIBRARY_PATH
280                 fi
281                 cat <<-EOF
282                         if [ "\${${var}+set}" = "set" ] ; then
283                                 export ${var}="\${${var}}:${EPREFIX}${libdir}"
284                         else
285                                 export ${var}="${EPREFIX}${libdir}"
286                         fi
287                 EOF
288         fi
289         # We don't want to quote ${bin} so that people can pass complex
290         # things as ${bin} ... "./someprog --args"
291         printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}/}"
292         ) > "${tmpwrapper}"
293         chmod go+rx "${tmpwrapper}"
294
295         if [[ -n ${path} ]] ; then
296                 (
297                 exeinto "${path}"
298                 newexe "${tmpwrapper}" "${wrapper}"
299                 ) || die
300         else
301                 newbin "${tmpwrapper}" "${wrapper}" || die
302         fi
303 }
304
305 # @FUNCTION: path_exists
306 # @USAGE: [-a|-o] <paths>
307 # @DESCRIPTION:
308 # Check if the specified paths exist.  Works for all types of paths
309 # (files/dirs/etc...).  The -a and -o flags control the requirements
310 # of the paths.  They correspond to "and" and "or" logic.  So the -a
311 # flag means all the paths must exist while the -o flag means at least
312 # one of the paths must exist.  The default behavior is "and".  If no
313 # paths are specified, then the return value is "false".
314 path_exists() {
315         local opt=$1
316         [[ ${opt} == -[ao] ]] && shift || opt="-a"
317
318         # no paths -> return false
319         # same behavior as: [[ -e "" ]]
320         [[ $# -eq 0 ]] && return 1
321
322         local p r=0
323         for p in "$@" ; do
324                 [[ -e ${p} ]]
325                 : $(( r += $? ))
326         done
327
328         case ${opt} in
329                 -a) return $(( r != 0 )) ;;
330                 -o) return $(( r == $# )) ;;
331         esac
332 }
333
334 # @FUNCTION: use_if_iuse
335 # @USAGE: <flag>
336 # @DESCRIPTION:
337 # Return true if the given flag is in USE and IUSE.
338 #
339 # Note that this function should not be used in the global scope.
340 use_if_iuse() {
341         in_iuse $1 || return 1
342         use $1
343 }
344
345 # @FUNCTION: optfeature
346 # @USAGE: <short description> <package atom to match> [other atoms]
347 # @DESCRIPTION:
348 # Print out a message suggesting an optional package (or packages)
349 # not currently installed which provides the described functionality.
350 #
351 # The following snippet would suggest app-misc/foo for optional foo support,
352 # app-misc/bar or app-misc/baz[bar] for optional bar support
353 # and either both app-misc/a and app-misc/b or app-misc/c for alphabet support.
354 # @CODE
355 #       optfeature "foo support" app-misc/foo
356 #       optfeature "bar support" app-misc/bar app-misc/baz[bar]
357 #       optfeature "alphabet support" "app-misc/a app-misc/b" app-misc/c
358 # @CODE
359 optfeature() {
360         debug-print-function ${FUNCNAME} "$@"
361         local i j msg
362         local desc=$1
363         local flag=0
364         shift
365         for i; do
366                 for j in ${i}; do
367                         if has_version "${j}"; then
368                                 flag=1
369                         else
370                                 flag=0
371                                 break
372                         fi
373                 done
374                 if [[ ${flag} -eq 1 ]]; then
375                         break
376                 fi
377         done
378         if [[ ${flag} -eq 0 ]]; then
379                 for i; do
380                         msg=" "
381                         for j in ${i}; do
382                                 msg+=" ${j} and"
383                         done
384                         msg="${msg:0: -4} for ${desc}"
385                         elog "${msg}"
386                 done
387         fi
388 }
389
390 case ${EAPI:-0} in
391 0|1|2)
392
393 # @FUNCTION: epause
394 # @USAGE: [seconds]
395 # @DESCRIPTION:
396 # Sleep for the specified number of seconds (default of 5 seconds).  Useful when
397 # printing a message the user should probably be reading and often used in
398 # conjunction with the ebeep function.  If the EPAUSE_IGNORE env var is set,
399 # don't wait at all. Defined in EAPIs 0 1 and 2.
400 epause() {
401         [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
402 }
403
404 # @FUNCTION: ebeep
405 # @USAGE: [number of beeps]
406 # @DESCRIPTION:
407 # Issue the specified number of beeps (default of 5 beeps).  Useful when
408 # printing a message the user should probably be reading and often used in
409 # conjunction with the epause function.  If the EBEEP_IGNORE env var is set,
410 # don't beep at all. Defined in EAPIs 0 1 and 2.
411 ebeep() {
412         local n
413         if [[ -z ${EBEEP_IGNORE} ]] ; then
414                 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
415                         echo -ne "\a"
416                         sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
417                         echo -ne "\a"
418                         sleep 1
419                 done
420         fi
421 }
422
423 ;;
424 *)
425
426 ebeep() {
427         ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at https://bugs.gentoo.org"
428 }
429
430 epause() {
431         ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at https://bugs.gentoo.org"
432 }
433
434 ;;
435 esac
436
437 case ${EAPI:-0} in
438 0|1|2|3|4)
439
440 # @FUNCTION: usex
441 # @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
442 # @DESCRIPTION:
443 # Proxy to declare usex for package managers or EAPIs that do not provide it
444 # and use the package manager implementation when available (i.e. EAPI >= 5).
445 # If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
446 # otherwise echo [false output][false suffix] (defaults to "no").
447 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
448
449 ;;
450 esac
451
452 case ${EAPI:-0} in
453 0|1|2|3|4|5)
454
455 # @FUNCTION: einstalldocs
456 # @DESCRIPTION:
457 # Install documentation using DOCS and HTML_DOCS.
458 #
459 # If DOCS is declared and non-empty, all files listed in it are
460 # installed. The files must exist, otherwise the function will fail.
461 # In EAPI 4 and subsequent EAPIs DOCS may specify directories as well,
462 # in other EAPIs using directories is unsupported.
463 #
464 # If DOCS is not declared, the files matching patterns given
465 # in the default EAPI implementation of src_install will be installed.
466 # If this is undesired, DOCS can be set to empty value to prevent any
467 # documentation from being installed.
468 #
469 # If HTML_DOCS is declared and non-empty, all files and/or directories
470 # listed in it are installed as HTML docs (using dohtml).
471 #
472 # Both DOCS and HTML_DOCS can either be an array or a whitespace-
473 # separated list. Whenever directories are allowed, '<directory>/.' may
474 # be specified in order to install all files within the directory
475 # without creating a sub-directory in docdir.
476 #
477 # Passing additional options to dodoc and dohtml is not supported.
478 # If you needed such a thing, you need to call those helpers explicitly.
479 einstalldocs() {
480         debug-print-function ${FUNCNAME} "${@}"
481
482         local dodoc_opts=-r
483         has ${EAPI} 0 1 2 3 && dodoc_opts=
484
485         if ! declare -p DOCS &>/dev/null ; then
486                 local d
487                 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
488                                 THANKS BUGS FAQ CREDITS CHANGELOG ; do
489                         if [[ -s ${d} ]] ; then
490                                 dodoc "${d}" || die
491                         fi
492                 done
493         elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
494                 if [[ ${DOCS[@]} ]] ; then
495                         dodoc ${dodoc_opts} "${DOCS[@]}" || die
496                 fi
497         else
498                 if [[ ${DOCS} ]] ; then
499                         dodoc ${dodoc_opts} ${DOCS} || die
500                 fi
501         fi
502
503         if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
504                 if [[ ${HTML_DOCS[@]} ]] ; then
505                         dohtml -r "${HTML_DOCS[@]}" || die
506                 fi
507         else
508                 if [[ ${HTML_DOCS} ]] ; then
509                         dohtml -r ${HTML_DOCS} || die
510                 fi
511         fi
512
513         return 0
514 }
515
516 # @FUNCTION: in_iuse
517 # @USAGE: <flag>
518 # @DESCRIPTION:
519 # Determines whether the given flag is in IUSE. Strips IUSE default prefixes
520 # as necessary.
521 #
522 # Note that this function should not be used in the global scope.
523 in_iuse() {
524         debug-print-function ${FUNCNAME} "${@}"
525         [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
526
527         local flag=${1}
528         local liuse=( ${IUSE} )
529
530         has "${flag}" "${liuse[@]#[+-]}"
531 }
532
533 ;;
534 esac
535
536 fi